package controller

import (
	"context"
	"encoding/json"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/os/glog"
	"go-gpt/gpt"

	"go-gpt/api/v1"
)

var (
	Hello = cHello{}
)

type Message struct {
	Content string `json:"content"`
}
type cHello struct{}

func (c *cHello) Hello(ctx context.Context, req *v1.HelloReq) (res *v1.HelloRes, err error) {
	re := g.RequestFromCtx(ctx)
	re.Response.Header().Set("Transfer-Encoding", "chunked")
	re.Response.Header().Set("Content-Type", "application/json")
	w := re.Response.Writer
	encoder := json.NewEncoder(w)

	// 初始化client
	client := gpt.NewClient("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")
	err = client.ChatCompletionStream(ctx, &gpt.ChatCompletionRequest{
		Model: gpt.GPT3Dot5Turbo,
		Messages: []gpt.ChatCompletionRequestMessage{
			{
				Role:    "user",
				Content: "编写一个c++冒泡算法",
			},
		},
		MaxTokens:   50,
		Temperature: 0,
	}, func(response *gpt.ChatCompletionStreamResponse) {

		// 检查Choices字段是否存在
		if len(response.Choices) > 0 {
			// 提取Content字段
			content := response.Choices[0].Delta.Content
			// 将Content字段作为一个JSON对象发送给客户端
			message := Message{Content: content}
			if err := encoder.Encode(message); err != nil {
				return
			}
			re.Response.WriteHeader(200)
			w.Flush()
		} else {
			re.Exit()
		}
	})

	if err != nil {
		glog.Debug(ctx, err)
		return
	}

	return
}
